'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var NAME = 'api.redux';
var API = NAME + '@middleware';

// Api actions.
var API_ACTIONS = ['NEW', 'CREATE', 'UPDATE', 'INDEX', 'SHOW', 'EDIT', 'DESTROY'];

// Backend actions.
var BACKEND_ACTIONS = {
  'NEW': '@_new_@',
  'CREATE': '@_create_@',
  'UPDATE': '@_update_@',
  'INDEX': '@_index_@',
  'SHOW': '@_show_@',
  'EDIT': '@_edit_@',
  'DESTROY': '@_destroy_@'
};

// Redux actions.
var ACTIONS = {
  'CLEAR': NAME + '.CLEAR'
};
var REDUX_STATES = ['START', 'SUCCESS', 'FAILURE'];

/**
 * Build the name of action api type.
 *
 * @param {string} apiAction - The action name (Ex: NEW).
 * @param {string} state     - The redux state (Ex: START).
 */
var apiTypeKey = function apiTypeKey(apiAction, state) {
  return 'API_' + apiAction + '_' + state;
};

// Build generic actions.
API_ACTIONS.forEach(function (apiAction) {
  REDUX_STATES.forEach(function (state) {
    var action = apiTypeKey(apiAction, state);

    ACTIONS[action] = NAME + '.' + action;
  });
});

exports.API = API;
exports.NAME = NAME;
exports.ACTIONS = ACTIONS;
exports.BACKEND_ACTIONS = BACKEND_ACTIONS;