'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getApiReduxByResource = undefined;

var _reselect = require('reselect');

var _constants = require('./constants');

var _init = require('./init');

var _memoize = require('lodash/memoize');

var _memoize2 = _interopRequireDefault(_memoize);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Create custom selector.
var hashFn = function hashFn() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return args.reduce(function (acc, val) {
    return acc + '-' + JSON.stringify(val);
  }, '');
};
var createApiReduxSelector = (0, _reselect.createSelectorCreator)(_memoize2.default, hashFn, _isEqual2.default);

/**
 * Get Api Redux state.
 */
var getApiRedux = function getApiRedux(state) {
  return state[_constants.NAME] || {};
};

/**
 * Get Api Resource scope.
 */
var getResource = function getResource(_state, props) {
  return props.apiResource;
};

/**
 * Get Api Redux state by Resource.
 */
var getApiReduxByResource = createApiReduxSelector([getApiRedux, getResource], function (apiRedux, resource) {
  var apiStates = apiRedux[resource] || {};

  Object.keys(_constants.BACKEND_ACTIONS).forEach(function (action) {
    var apiAction = _constants.BACKEND_ACTIONS[action];

    apiStates[apiAction] = apiStates[apiAction] || (0, _init.getInit)(apiAction);
  });

  return apiStates;
});

exports.getApiReduxByResource = getApiReduxByResource;